ClassFile.ConstantPoolSharingOption (Java SE 22 & JDK 22)
Description: declaration: module: java.base, package: java.lang.classfile, interface: ClassFile, enum: ConstantPoolSharingOption
Keywords: java.lang.classfile.ClassFile.ConstantPoolSharingOption class

Module java.base
Package java.lang.classfilePREVIEW

# Enum Class ClassFile.ConstantPoolSharingOption

java.lang.Object
java.lang.Enum<ClassFile.ConstantPoolSharingOptionPREVIEW>
java.lang.classfile.ClassFile.ConstantPoolSharingOption

All Implemented Interfaces:
  `Serializable`, `ClassFile.OptionPREVIEW`, `Comparable<ClassFile.ConstantPoolSharingOptionPREVIEW>`, `Constable`

Enclosing interface:
  `ClassFilePREVIEW`

public static enum ClassFile.ConstantPoolSharingOption extends Enum<ClassFile.ConstantPoolSharingOptionPREVIEW> implements ClassFile.OptionPREVIEW
`ConstantPoolSharingOption` is a preview API of the Java platform.
Programs can only use `ConstantPoolSharingOption` when preview features are enabled.
Preview features may be removed in a future release, or upgraded to permanent features of the Java platform.
Option describing whether to preserve the original constant pool when transforming a classfile. Reusing the constant pool enables significant optimizations in processing time and minimizes differences between the original and transformed classfile, but may result in a bigger classfile when a classfile is significantly transformed. Default is `SHARED_POOL` to preserve the original constant pool.

Since:
  22

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `NEW_POOL`
  Creates a new constant pool when transforming classfile
  `SHARED_POOL`
  Preserves the original constant pool when transforming classfile

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ClassFile.ConstantPoolSharingOptionPREVIEW`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ClassFile.ConstantPoolSharingOptionPREVIEW[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods declared in class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### SHARED_POOL

    public static final ClassFile.ConstantPoolSharingOptionPREVIEW SHARED_POOL
    Preserves the original constant pool when transforming classfile

  - ### NEW_POOL

    public static final ClassFile.ConstantPoolSharingOptionPREVIEW NEW_POOL
    Creates a new constant pool when transforming classfile

- ## Method Details

  - ### values

    public static ClassFile.ConstantPoolSharingOptionPREVIEW[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ClassFile.ConstantPoolSharingOptionPREVIEW valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null